{
 DBButton:
    Used to take a table action by sepcifying Action property.
    Copyrights : EPOCH-ITG 1999.
}
unit Dbbtn;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, StdCtrls,Db;


type

//
// List of actions that dbbutton can do.
//
  TButtonType = (btPost, btDelete, btEdit, btAppend, btRefresh, btCancel, btNext, btPrev,
                 btLast, btFirst, btNone);

  TActionEvent = procedure (Sender: TObject; tSet: TDataSet; var Action: TButtonType) of object;

  TDBButton = class(TButton)
  private
    FButtonType: TButtonType;
    FDataLink: TDataSource;
    FDoFormClose: boolean;
    FBeforeAction: TActionEvent;
    FAfterAction: TActionEvent;

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
  published
    property ButtonType: TButtonType read FButtonType write FButtonType;
    property DataSource: TDataSource read FDataLink write FDataLink;
    property CloseForm: boolean read FDoFormClose write FDoFormClose;
    property BeforeAction: TActionEvent read FBeforeAction write FBeforeAction;
    property AfterAction: TActionEvent read FAfterAction write FAfterAction;
  end;


procedure Register;

implementation


procedure Register;
begin
    RegisterComponents('Data Controls', [TDBButton]);
end;

constructor TDBButton.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    FButtonType  := btNone;
    FDataLink    := nil;
    FDoFormClose := false;
end;

destructor TDBButton.Destroy;
begin
    inherited Destroy;
end;

procedure TDBButton.Click;
var
    Action: TButtonType;
begin
    inherited Click;

    Action := FButtonType;

    if FDataLink <> nil then
        begin
        if ( Assigned(FBeforeAction) ) then
            begin
            FBeforeAction(self, FDataLink.DataSet, Action);
            end;

        if ( FButtonType = btNone ) then
            begin
            end
        else if ( Action = btPost ) then
            begin
            FDataLink.DataSet.Post();
            end
        else if ( Action = btAppend ) then
            begin
            FDataLink.DataSet.Append();
            end
        else if ( Action = btEdit ) then
            begin
            FDataLink.DataSet.Edit();
            end
        else if ( Action = btDelete ) then
            begin
            FDataLink.DataSet.Delete();
            end
        else if ( Action = btRefresh ) then
            begin
            FDataLink.DataSet.Refresh();
            end
        else if ( Action = btFirst ) then
            begin
            FDataLink.DataSet.First();
            end
        else if ( Action = btNext ) then
            begin
            FDataLink.DataSet.Next();
            end
        else if ( Action = btPrev ) then
            begin
            FDataLink.DataSet.Prior();
            end
        else if ( Action = btLast ) then
            begin
            FDataLink.DataSet.Last();
            end
        else if ( Action = btCancel ) then
            begin
            FDataLink.DataSet.Cancel();
            end;

        if ( Assigned(FAfterAction) ) then
            begin
            FAfterAction(self, FDataLink.DataSet, FButtonType);
            end;
        end;

    if ( FDoFormClose ) then
        begin
        TForm(Owner).Close();
        end;
end;

end.
